package cn.com.infosec.crypto.params;

import cn.com.infosec.math.ec.ECConstants;
import cn.com.infosec.math.ec.ECCurve;
import cn.com.infosec.math.ec.ECPoint;
import java.math.BigInteger;

public class ECDomainParameters implements ECConstants {
   ECCurve curve;
   byte[] seed;
   ECPoint G;
   BigInteger n;
   BigInteger h;

   public ECDomainParameters(ECCurve curve, ECPoint G, BigInteger n) {
      this.curve = curve;
      this.G = G;
      this.n = n;
      this.h = ECConstants.ONE;
      this.seed = null;
   }

   public ECDomainParameters(ECCurve curve, ECPoint G, BigInteger n, BigInteger h) {
      this.curve = curve;
      this.G = G;
      this.n = n;
      this.h = h;
      this.seed = null;
   }

   public ECDomainParameters(ECCurve curve, ECPoint G, BigInteger n, BigInteger h, byte[] seed) {
      this.curve = curve;
      this.G = G;
      this.n = n;
      this.h = h;
      this.seed = seed;
   }

   public ECCurve getCurve() {
      return this.curve;
   }

   public ECPoint getG() {
      return this.G;
   }

   public BigInteger getN() {
      return this.n;
   }

   public BigInteger getH() {
      return this.h;
   }

   public byte[] getSeed() {
      return this.seed;
   }
}
